unit UElement;

interface
uses classes,SysUtils;
Type
  TdirectionSet  = (dleft,dright,dup,ddown);
 
  TElement = Class
    Col   : integer;
    Lig   : integer;
    Dir   : TdirectionSet;
    Constructor Create(aCol,alig: integer;aDir: TdirectionSet);
  end;

  TListElt = Class(Tlist)
  Private
    Function GetItems (Index : integer) : TElement ;
  Protected
    procedure Notify(Ptr: Pointer; Action: TListNotification); override;
  public
    Procedure Add (AObject : TElement) ;
    Procedure EnleveFirstElt;
    Property Items [Index : integer] : TElement Read GetItems ;
  End ;

implementation


Constructor TElement.Create(aCol,aLig: integer;aDir:TdirectionSet);
begin
  Dir   := aDir;
  Col   := aCol;
  Lig   := aLig;
end;

Function TListElt.GetItems (Index : integer) : TElement ;
Begin
  If Index >= Count Then
    raise Exception.CreateFmt ('Index (%d) outside range 1..%d',[Index, Count -1 ]) ;
  Result := Inherited Items [Index] ;
End ;

Procedure TListElt.Add (AObject : TElement) ;
Begin
  Inherited Add (AObject) ;
End ;

Procedure TListElt.EnleveFirstElt ;
begin
  Delete(0);
end;

procedure TListElt.Notify(Ptr: Pointer; Action: TListNotification);
begin
  if Action =  lnDeleted  Then
    Tobject(Ptr).Free;
  inherited;
end;

end.
