unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus,Udata,UElement, ImgList, StdCtrls, ExtCtrls;

type
  TMainFrm = class(TForm)
    Imgterrain: TImage;
    ImgElement: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);

  private
    { Dclarations prives }
    ObJeux : TClassJeu;
    procedure GrilleDrawCell(Sender: TCanvas; ACol, ARow: Integer;aRect: TRect);
    Procedure EltAffiche;

    Procedure DessineTerrain(Canvas : TCanvas;aRect : Trect;IndImg : integer);

    Procedure DessineVide(Canvas : TCanvas;aRect : Trect;IndImg : integer);
    Procedure DessineObstacle(Canvas : TCanvas;aRect : Trect;IndImg : integer);
    Procedure DessineMurPlein(Canvas : TCanvas;aRect : Trect;IndImg : integer);
    Procedure DessineMurCoin(Canvas : TCanvas;aRect : Trect;IndImg : integer);

    Procedure DessineElement(Canvas : TCanvas;aRect : Trect;IndImg : integer);

    Procedure DessineNouriture0(Canvas : TCanvas;aRect : Trect;IndImg : integer);
    Procedure DessineNouriture1(Canvas : TCanvas;aRect : Trect;IndImg : integer);
    Procedure DessineNouriture2(Canvas : TCanvas;aRect : Trect;IndImg : integer);
    Procedure DessineNouriture3(Canvas : TCanvas;aRect : Trect;IndImg : integer);
    Procedure DessinePoison(Canvas : TCanvas;aRect : Trect;IndImg : integer);
    Procedure DessineTete(Canvas : TCanvas;aRect : Trect;IndImg : integer);
    Procedure Dessinecorps(Canvas : TCanvas;aRect : Trect;IndImg : integer);

    Function  DetermineCoin( ACol, ARow: Integer) : Integer;
    Function  DetermineMurObstacle(ACol, ARow: Integer) : integer;
    Function  DetermineTete(ACol, ARow: Integer) : integer;
    Function  DetermineCorps(ACol, ARow: Integer) : integer;

    Procedure DessineBasDepage;

    Procedure EvtPerdu;
    Procedure EvtInterdit;
    Procedure BoucleTempo;

  protected
    procedure WMPaint(var Msg: TWMPaint); message WM_PAINT;
    procedure WMEventMove(var Msg: TMessage); message WM_EVENTMOVE;
    { Dclarations publiques }
  end;



var
  MainFrm: TMainFrm;

implementation
 uses mmsystem;
{$R *.dfm}


procedure TMainFrm.WMPaint(var Msg: TWMPaint);
var
 ps : TPaintStruct;
 i,j : Integer;
 arect : Trect;
begin
 BeginPaint(Handle, ps);
 for i:= low(ObJeux.Grille) to high(ObJeux.Grille) do
 begin
   for j:= low(ObJeux.Grille[i]) to high(ObJeux.Grille[i]) do
   begin
      arect.Left   := (i*deltax);
      arect.Right  := ((i+1)*deltax);
      arect.Top    := ((j)*deltay);
      arect.Bottom := ((j+1)*deltay);
      GrilleDrawCell(Canvas,i,j,arect);
    end;
  end;

  DessineBasDepage;
 EndPaint(Handle, ps);
end;

Procedure TMainFrm.DessineBasDepage;
var
x,y : Integer;
begin
  canvas.Font.Color := clRed;
  canvas.Font.Height := 15;
  canvas.Font.Size := 15;
  y :=((MaxCol+1)*deltay)-ClientHeight+deltay ;
  x := 0;
  Canvas.Brush.Color :=  clBackground;
  Canvas.FillRect(Rect(x,ClientHeight-(y),ClientWidth-1,ClientHeight));
  canvas.TextOut(x+10,ClientHeight-round(y/2),format('Score  :%d',[ObJeux.Score]));
  canvas.TextOut(x+200,ClientHeight-round(y/2),format('Nb vie :%d',[ObJeux.NbVie]));
  canvas.TextOut(x+400,ClientHeight-round(y/2),format('Niveau :%d',[ObJeux.CurrLevel]));
  canvas.Font.Color := clBlack;
  canvas.Font.Height := 8;
end;
Procedure TMainFrm.EltAffiche;
begin
  InvalidateRect(Handle, nil, False);
end;

Procedure TMainFrm.Evtinterdit;
begin
//
end;

Procedure TMainFrm.EvtPerdu;
begin
  ObJeux.NbVie := ObJeux.NbVie-1;
  if ObJeux.NbVie <= 0 Then
  begin
    ObJeux.NbVie := 3;
    ObJeux.Score :=0;
    if MessageDlg('Perdu ! Mouvement impossible.  Recommencer une partie ?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
       ObJeux.RejouerPartie
    end
    else
       Close;
   end
   else
   if MessageDlg('Perdu ! Mouvement impossible.  Continuer ?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
     ObJeux.RejouerPartie
   end
   else
     Close;
end;

Procedure TMainFrm.DessineTerrain(Canvas : TCanvas;aRect : Trect;IndImg : integer);
var
  MyDestRect, MySrcRect: TRect;
begin
  MySrcRect := Rect(IndImg*LargImg,0,(IndImg*LargImg)+LargImg,Hautimg);
  MyDestRect :=  aRect;
  Canvas.BrushCopy(MyDestRect, Imgterrain.Picture.Bitmap, MySrcRect, clBlack);
end;

Procedure TMainFrm.DessineElement(Canvas : TCanvas;aRect : Trect;IndImg : integer);
var
  MyDestRect, MySrcRect: TRect;
begin
  MySrcRect := Rect(IndImg*LargImg,0,(IndImg*LargImg)+LargImg,Hautimg);
  MyDestRect :=  aRect;
  Canvas.BrushCopy(MyDestRect, ImgElement.Picture.Bitmap, MySrcRect, clBlack);
end;

Procedure TMainFrm.DessineVide(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
  DessineTerrain(canvas,arect,IndImg);
end;

Procedure TMainFrm.DessineNouriture0(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
  DessineElement(Canvas,arect,IndImg);
end;

Procedure TMainFrm.DessineNouriture1(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
  DessineElement(Canvas,arect,IndImg);
end;

Procedure TMainFrm.DessineNouriture2(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
  DessineElement(Canvas,arect,IndImg);
end;

Procedure TMainFrm.DessineNouriture3(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
  DessineElement(Canvas,arect,IndImg);
end;

Procedure TMainFrm.DessinePoison(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
  DessineElement(Canvas,arect,IndImg);
end;

Function  TMainFrm.DetermineMurObstacle(ACol, ARow: Integer) : integer;
begin
 result := 0;
{ // --- encours de developpement
  Res := 0;
  if ObJeux.grille[ACol, ARow-1] in [Obstacle,MurPlein,MurCoin] Then
    Res :=Res+ 1;
  if ObJeux.grille[ACol, ARow+1] in [Obstacle,MurPlein,MurCoin]Then
    Res :=Res+ 2;
  if ObJeux.grille[ACol-1, ARow] in [Obstacle,MurPlein,MurCoin]Then
    Res :=Res+ 4;
  if ObJeux.grille[ACol+1, ARow] in [Obstacle,MurPlein,MurCoin]Then
    Res :=Res+8;
  case Res of
  1 : result := ImgHorB;
  2 : result := ImgHorH;
  3 : result := 0;
  4 : result := ImgVertG;
  5 : result := ImgbgP;
  6 : result := ImghgP;
  7 : result := ImgVertG;
  8 : result := ImgVertD;
  9 : result := ImgbdP;//coin
  10: result := ImghdP;//coin
  11: result := ImgVertD;
  12: result := 0;
  13: result := ImgHorb;
  14: result := ImgHorH;
  15: result := ImgPlein1;
 end;}
end;

Procedure TMainFrm.DessineObstacle(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
//  DessineTerrain(canvas,aRect,IndImg);
  Canvas.Brush.Color := clInfoBk;
  Canvas.FillRect(aRect);
  Canvas.Brush.Color :=clBlack;
end;

Procedure TMainFrm.DessineMurCoin(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
 // DessineTerrain(canvas,aRect,IndImg);
  Canvas.Brush.Color := clInfoBk;
  Canvas.FillRect(aRect);
  Canvas.Brush.Color :=clBlack;
end;


Procedure TMainFrm.DessineMurPlein(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
//  DessineTerrain(canvas,aRect,IndImg);
  Canvas.Brush.Color := clBackground;
  Canvas.FillRect(aRect);
  Canvas.Brush.Color :=clBlack;
end;

Procedure TMainFrm.DessineTete(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
 // DessineElement(canvas,aRect,IndImg);
  Canvas.Pen.Color := clGreen;
  Canvas.Rectangle(aRect);
  Canvas.Pen.Color := clBlack;
end;

Procedure TMainFrm.Dessinecorps(Canvas : TCanvas;aRect : Trect;IndImg : integer);
begin
// DessineElement(canvas,aRect,IndImg);
  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Color := clGreen;
  Canvas.FillRect(aRect);
  Canvas.Rectangle(aRect);
  Canvas.Brush.Color :=clBlack;
  Canvas.Pen.Color := clBlack;
end;


procedure TMainFrm.FormCreate(Sender: TObject);
begin
  ObJeux := TClassJeu.Create;
  ClientWidth  :=  (MaxCol+1)*deltax;
  ClientHeight :=  (MaxLig+1)*deltay+HauteurZoneInfo;
  ObJeux.DrawElement := EltAffiche;
  ObJeux.mvtimpossible := EvtPerdu;
  ObJeux.mvtinterdit   := EvtInterdit;
  ObJeux.mvtHorsLimite := EvtPerdu;
  Postmessage(handle,WM_EVENTMOVE,0,0);
  DoubleBuffered := True;
end;

Function TMainFrm.DetermineCorps(ACol, ARow: Integer) : integer;
//var
// Somme : byte;
begin
 result := 0;
{ // --- encours de developpement
  Somme := 0;
  if (ObJeux.Grille[Acol-1,ARow+1]in [Tete, corps]) then
    Somme := Somme+1 ;

  if (ObJeux.Grille[Acol,ARow+1]in [Tete, corps]) then
    Somme := Somme+2 ;
  if (ObJeux.Grille[Acol+1,ARow+1] in [Tete, corps])then
    Somme := Somme+4;

  if (ObJeux.Grille[Acol+1,ARow]in [Tete, corps])then
    Somme := Somme+8;
  if (ObJeux.Grille[Acol-1,ARow] in [Tete, corps]) then
    Somme := Somme+16;

  if (ObJeux.Grille[Acol+1,ARow-1] in [Tete, corps]) then
    Somme := Somme+32;
  if (ObJeux.Grille[Acol,ARow-1] in [Tete, corps]) then
     Somme := Somme+64;
  if (ObJeux.Grille[Acol-1,ARow-1] in [Tete, corps]) then
     Somme := Somme+128;
    result := Somme;
  result :=9;
  case Somme of
   9,12,40,20,24,25,144 : result := 8;
   3,19,98,66,67,192  : result := 9;
   80 : result := 13;
   72 : result := 12;
   18 : result := 11;
   10 : result := 10;
   5  : result := 4;
   7,16  : result := 6;
   2  : result := 7;
   64  : result := 7;
   8,6 : result := 5;
  end;
}
end;
procedure TMainFrm.GrilleDrawCell(Sender: TCanvas; ACol, ARow: Integer;aRect: TRect);
var
 Snake : TCase;
begin
  Snake := ObJeux.Grille[Acol,Arow];
  case Snake of
    Vide         : DessineVide(canvas,arect,12);
    Nouriture0   : DessineNouriture0(canvas,arect,14);
    Nouriture1   : DessineNouriture1(canvas,arect,15);
    Nouriture2   : DessineNouriture2(canvas,arect,15);
    Nouriture3   : DessineNouriture3(canvas,arect,16);
    Poison       : DessinePoison(canvas,arect,17);
    Obstacle     : DessineObstacle(canvas,arect,DetermineMurObstacle(ACol, ARow));
    MurPlein     : DessineMurPlein(canvas,arect,17);
    MurCoin      : DessineMurCoin(canvas,arect,DetermineCoin(ACol, ARow));
    Tete         : DessineTete(canvas,arect,DetermineTete(ACol, ARow));
    corps        : Dessinecorps(canvas,arect,DetermineCorps(ACol, ARow));
  end;
end;

Function  TMainFrm.DetermineTete(ACol, ARow: Integer) : Integer;
begin
  case ObJeux.CurDir of
    dleft  : result := 0;
    dright : result := 1;
    dup    : result := 3;
    ddown  : result := 2;
  else
   result := 0;
 end;
end;

Function  TMainFrm.DetermineCoin( ACol, ARow: Integer) : Integer;
//var
// Somme : byte;
begin
  result := 0;
 { // --- encours de developpement
  Somme := 0;
  if (ObJeux.Grille[Acol-1,ARow-1]in [Obstacle,MurPlein,MurCoin]) then
    Somme := Somme+1 ;
  if (ObJeux.Grille[Acol-1,ARow+1] in [Obstacle,MurPlein,MurCoin])then
    Somme := Somme+2;
  if (ObJeux.Grille[Acol+1,ARow+1]in [Obstacle,MurPlein,MurCoin])then
    Somme := Somme+4;
  if (ObJeux.Grille[Acol+1,ARow-1] in [Obstacle,MurPlein,MurCoin]) then
    Somme := Somme+8;
  case Somme of
   1  : Result := 0;
   2  : Result := 0;
   3  : Result := 0;
   4  : Result := 0;
   5  : Result := 0;
   6  : Result := 0;
   7  : Result := 0;
   8  : Result := 0;
   9  : Result := 0;
   10 : Result := 0;
   11 : Result := 0;
   12 : Result := 0;
   13 : Result := 0;
   14 : Result := 0;
   15 : Result := 0; // Tous les diago sont pleine
  else
    Result := 0; //etat inconnue
  end;}
end;

procedure TMainFrm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    ORD('P')    : ObJeux.Pause := true;
    VK_RETURN : if ObJeux.pause Then
                begin
                  ObJeux.Pause := False;
                  Postmessage(handle,WM_EVENTMOVE,0,0);
                end;
    VK_LEFT   : if ObJeux.pause = false Then
                  ObJeux.MoveElt(TElement.Create(ObJeux.CurCol-1 ,ObJeux.CurLig,dleft));
    VK_RIGHT  : if ObJeux.pause = false Then
                  ObJeux.MoveElt(TElement.Create(ObJeux.CurCol+1 ,ObJeux.CurLig,dright));
    VK_UP     : if ObJeux.pause = false Then
                 ObJeux.MoveElt(TElement.Create(ObJeux.CurCol   ,ObJeux.CurLig-1,dup));
    VK_DOWN   : if ObJeux.pause = false Then
                  ObJeux.MoveElt(TElement.Create(ObJeux.CurCol   ,ObJeux.CurLig+1,ddown));
    VK_ESCAPE : Close;
  end;
end;

procedure TMainFrm.WMEVENTMOVE(var Msg: TMessage);
Begin
  if not(ObJeux.Pause) then
  begin
    case ObJeux.Snake.CurrentDir of
      dleft  : ObJeux.MoveElt(Telement.Create(ObJeux.CurCol-1,ObJeux.CurLig ,ObJeux.CurDir));
      dright : ObJeux.MoveElt(Telement.Create(ObJeux.CurCol+1,ObJeux.CurLig ,ObJeux.CurDir));
      dup    : ObJeux.MoveElt(Telement.Create(ObJeux.CurCol,ObJeux.CurLig-1 ,ObJeux.CurDir));
      ddown  : ObJeux.MoveElt(Telement.Create(ObJeux.CurCol,ObJeux.CurLig+1 ,ObJeux.CurDir));
    end;

    if not(ObJeux.Encours) Then
    begin
      BoucleTempo;
      Postmessage(handle,WM_EVENTMOVE,0,0);
    end;
 end;
End;

Procedure TMainFrm.BoucleTempo;
 var Top : cardinal;
begin
  if assigned(ObJeux.Niveau) Then
  begin
    Top:=GetTickCount;
    repeat
      Application.ProcessMessages;
    until GetTickCount-Top>ObJeux.Niveau.vitesse;
 end;
end;

procedure TMainFrm.FormResize(Sender: TObject);
begin
  InvalidateRect(Handle, nil, False);
end;

end.



