unit Udata;

interface
uses Windows,Messages,UElement,UNiveau;
const
  Hautimg = 17;
  LargImg = 17;

Const
  deltax = 16;
  deltay = 16;

  MaxCol = 36;
  MaxLig = 24;
  HauteurZoneInfo = 100;

  WM_EVENTMOVE = wm_User+4;
  WM_OBJFREE   = wm_User+5;
Type
  TCase          = (Vide,Nouriture0,Nouriture1,Nouriture2,Nouriture3,Poison,Obstacle,MurPlein,MurCoin,Tete, corps);
  TDrawElement   = Procedure of Object;
  TMethodeEvt    = Procedure of Object;
  TAddElement    = Procedure(value : String) of Object;
  TPlaceElement  = Procedure(Col,Lig : Integer;Snake : Tcase)of Object;

type
  TGrille  = array[0..MaxCol,0..MaxLig]of TCase ;

  TSnake = Class
    Lst          : TListElt;
    PlaceElement : TPlaceElement;
    CurrentDir   : TdirectionSet;
    Constructor Create;
    Procedure Add(Elt  : TElement);
    Procedure Move(Elt : TElement);
    Procedure EnleveFirstEvt;
    Destructor Destroy; override;
  end;

  TClassJeu = Class
  Private
    fNiveau       : TNiveau;
    fSnake        : TSnake;
    fGrille       : TGrille;
//    lstEvent      : TListElt;
//    lstGagnant    : TListElt;
    Function VerifieMvt(Evt : Telement): Boolean;
    procedure initialiseGrille;
    procedure InitialiseSnake(alig : integer);
    procedure InitialiseSnake2(aCol,alig : integer);
    procedure ChargeCarte(FileName : String);
  Public
    CurCol    : integer;
    CurLig    : Integer;
    CurDir    : TdirectionSet;
    CurrLevel    : Integer;
    Score        : Integer;
    NbVie        : integer;
    Encours      : Boolean;
    Pause        : Boolean;
    DrawElement    : TDrawElement;
    AddElement     : TAddElement;
    mvtimpossible  : TMethodeEvt;
    mvtinterdit    : TMethodeEvt;
    mvtHorsLimite  : TMethodeEvt;
    Constructor Create;
    Destructor Destroy; override;

    procedure MoveElt(Elt : TElement);
    procedure AddElt(Elt : TElement);
    procedure PlaceNouriture;
    procedure RejouerPartie;
    procedure Reinitialisation;
    procedure PlacePion(Col,Lig : Integer;Snake : TCase);
    procedure MessageLog(msg : String);
    Property Grille  : TGrille Read fGrille write fGrille;
    Property Snake   : TSnake Read fSnake;
    Property Niveau  : TNiveau Read fNiveau;
  end;

  var
    ObJeux : TClassJeu;

implementation
uses Dialogs,SysUtils,Classes;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
Constructor TSnake.Create;
begin
  lst := TListElt.Create;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
Procedure TSnake.Add(Elt : TElement);
var
  LastElt: TElement;
begin
  if Assigned(PlaceElement) Then
  begin
    if lst.Count > 0 Then
    begin
      LastElt := lst.Items[Pred(lst.Count)];
      PlaceElement(LastElt.Col,LastElt.Lig,Corps);
    end;
  end;
  lst.Add(Elt);
  CurrentDir := Elt.Dir;
  if Assigned(PlaceElement) Then
    PlaceElement(Elt.Col,Elt.Lig,Tete);
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
Procedure TSnake.EnleveFirstEvt;
var
 FirstEvt : TElement;
begin
  if Assigned(PlaceElement) Then
  begin
    FirstEvt := lst.Items[0];
    PlaceElement(FirstEvt.Col,FirstEvt.Lig,vide);
  end;
  lst.EnleveFirstElt;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
Procedure TSnake.Move(Elt : TELement);
begin
  Add(Elt);
  EnleveFirstEvt;
end;
Destructor TSnake.Destroy;
begin
  lst.Clear;
  lst.Free;
  Inherited;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
Constructor TClassJeu.Create;
begin
  CurrLevel    := 1;
  Score        := 0;
  NbVie        := 3;
  fNiveau  := TNiveau.create;
  fSnake := TSnake.Create;
  fSnake.PlaceElement := PlacePion;
  Reinitialisation;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.initialiseGrille;
var
 i:integer;
begin
  FillChar(fgrille,sizeof(fgrille),vide);
  For i:= low(fgrille) to High(fgrille) do
  begin
    fgrille[i, low(fgrille[0])] := MurPlein;
    fgrille[i,High(fgrille[0])] := MurPlein;
  end;

  For i:= low(fgrille[0]) to High(fgrille[0]) do
  begin
    fgrille[low(fgrille),i] := MurPlein;
    fgrille[High(fgrille),i] := MurPlein;
  end;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.InitialiseSnake2(aCol,alig : integer);
begin
  if fSnake.Lst.Count > 0 Then
    fSnake.Lst.Clear;
  AddElt(TElement.Create(aCol-3,alig,dright));
  AddElt(TElement.Create(aCol-2,alig,dright));
  AddElt(TElement.Create(aCol-1,alig,dright));
  AddElt(TElement.Create(aCol,alig,dright));
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.InitialiseSnake(alig : integer);
begin
  fSnake.Lst.Clear;
  AddElt(TElement.Create(15,alig,dup));
  AddElt(TElement.Create(15,alig-1,dup));
  AddElt(TElement.Create(15,alig-2,dup));
  AddElt(TElement.Create(15,alig-3,dup));
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.ChargeCarte(FileName : String);
var
  Fls : Tfilestream;
  x,y : integer;
  car : Char;
  st : string;
begin
  st := ParamStr(0);
  st := ExtractFilePath(st);
  fSnake.Lst.Clear;
  Fls := Tfilestream.Create(st+FileName,fmOpenRead);
  x :=0;
  y :=0;
  fNiveau.nbPomme :=0;
  while Fls.Position < Fls.Size do
  begin
    Fls.Read(car,1);
    if (car = #10)then
    begin
      x := 0;
      y := y+1;
    end;
    if (car <> #10) and (car <> #13) then
    begin
      case car of
       '0' : fGrille[x,y] := MurPlein;
       '*' : fGrille[x,y] := MurCoin;
       'O' : fGrille[x,y] := obstacle;
       'P' : begin
               fGrille[x,y] := Nouriture0;
               fNiveau.nbPomme := fNiveau.nbPomme+1;
             end;
       'S' : InitialiseSnake2(x,y);
      end;
      x := x+1;
    end;
  end;
  Fls.Free;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.Reinitialisation;
var
  y:integer;
  nom : String;
  i : integer;

begin
  fSnake.Lst.Clear;
  FillChar(fGrille,sizeof(fGrille),vide);
  nom := Format('Niveau%d.txt',[CurrLevel]);
//  fNiveau.LitNiveau(nom);
  if   CurrLevel < 6 Then
    ChargeCarte(Format('maps\l%d.txt',[CurrLevel]))
  else
  begin
    randomize;
    y:= Round(Maxlig/2);
    ObJeux.Niveau.vitesse := ObJeux.Niveau.vitesse - 50;
    if ObJeux.Niveau.vitesse < 0 Then
      ObJeux.Niveau.vitesse := 0;

    initialiseGrille;
    InitialiseSnake(y);
    for i := 0 to 6 do
    begin
      fNiveau.nbPomme := fNiveau.nbPomme+1;
      PlaceNouriture;
    end;
  end;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.PlaceNouriture;
var
  x,y : integer;
begin
  x:= -1;
  y:= -1;
  randomize;
  while not ((x < High(Grille)) and (x > low(Grille))
    and (y < High(Grille[0]))
    and (y > low(Grille[0])))  do
    begin
      x:= random(MaxCol);
      y:= random(Maxlig);
    end;

    if Grille[x,y] <> vide Then
      PlaceNouriture
    else
      PlacePion(x,y,Nouriture1);
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.MoveElt(Elt : TElement);
begin
  if VerifieMvt(Elt) Then
  begin
    case  fGrille[Elt.Col,Elt.Lig]  of
      corps,tete  : begin
                     if assigned(mvtimpossible) Then
                       mvtimpossible ;
                    end;
      Nouriture0,Nouriture1,
      Nouriture2,Nouriture3 : begin	//la case pomme
                                AddElt(Elt);
                                fNiveau.nbPomme := fNiveau.nbPomme -1;
                                Score := Score+5;
                                if fNiveau.nbPomme = 0 Then
                                begin
                                  CurrLevel := CurrLevel+1;
                                  Reinitialisation;
                                end;
                              end;
    vide :  begin  // la case est vide
              CurCol := Elt.Col;
              CurLig := Elt.Lig;
              CurDir :=  Elt.Dir;
              fSnake.Move(Elt)
            end;
    Obstacle : begin  //c'est un obstacle
                  Encours := False;
                  if assigned(mvtinterdit) Then
                      mvtinterdit ;
               end;
    Poison : begin	//la case pomme
               AddElt(Elt);
               Score := Score+5;
              PlaceNouriture
             end;
    MurCoin : begin  //c'est un mur plein
                  Encours := False;
                  if assigned(mvtinterdit) Then
                      mvtinterdit ;
                end;
    MurPlein : begin  //c'est un mur plein
                     Encours := False;
                     if assigned(mvtimpossible) Then
                       mvtimpossible ;
                   end;
    else
    begin  //c'est un obstacle
      Encours := False;
      if assigned(mvtinterdit) Then
          mvtinterdit ;
    end;
  end;
  end
  else //on est en dehors des limite
  if assigned(mvtHorsLimite) Then
     mvtHorsLimite ;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.AddElt(Elt : TElement);
begin
 CurCol := Elt.Col;
 CurLig := Elt.Lig;
 CurDir := Elt.Dir;
 fSnake.Add(Elt);
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.RejouerPartie;
begin
  Reinitialisation;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
Function TClassJeu.VerifieMvt(Evt : Telement) : Boolean;
begin
  Result := True;
  If (Evt.Col < 1) or (Evt.Col > MaxCol-1) Then
    Result := False;

  If (Evt.Lig < 1) or (Evt.Lig > MaxLig-1) Then
    Result := False;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.PlacePion(Col,Lig : Integer;Snake : Tcase);
begin
  if   ((Col < High(Grille))   and (Col > low(Grille))
    and (Lig < High(Grille[0]))and (Lig > low(Grille[0])))  then
  begin
    fgrille[Col,Lig] :=Snake;
    if assigned(DrawElement) Then
      DrawElement;
  end;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
procedure TClassJeu.MessageLog(msg : String);
begin
  //
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}
Destructor TClassJeu.Destroy;
begin
  fSnake.Free;
  fNiveau.Free;
  Inherited;
end;
{Oo--oO-Oo--oO/-\Oo--oO-Oo--oO}

end.



